import processing.serial.*;
import controlP5.*;
import java.util.Map;

Serial myPort;
byte[] inBuffer = new byte[255];
String id[]=new String[4];
String mp[]=new String[4];
char dec=2;   //si >=2 erreur, sinon indique le decalage necessaire pour la lecture
int num;
String myString;  // Input string from serial port

ControlP5 cp5;
//boolean actu;
boolean modif;
boolean init;  //attente de reception de données pour affichage
boolean finInit;
int suppr=4; //compteur de tour pour suppression des cadres
PFont font = createFont("arial", 20);

void setup() {
  /************
   for(int i=0;i<4;i++) id[i]="nouveau";
   ************/

  modif=false;
 // actu=false;
  size(600, 600);
  cp5 = new ControlP5(this);
  myPort=new Serial(this, Serial.list()[0], 9600);
  
  init=true;
  finInit=false;
  //finInit=true;
  demande();
}

/********************
 * partie affichage *
 ********************/

void draw() {
  lecture();
  decor();
  //if(actu==true) demande();
  if (finInit==true) afficher();
}

void afficher() {
  init=false;
  finInit=false;
  cp5.addScrollableList("Identifiants")
    .setPosition(220, 100)
      .setSize(200, 200)
        .setBarHeight(30)
          .setItemHeight(25)
            .addItems(id)
              .setColorBackground(color(155, 75, 80));

  cp5.addButton("Modifier")
    .setPosition(440, 100)
      .setSize(100, 30)
        .setColorBackground(color(155, 75, 80));
}

void decor() {
  background(100);
  fill(255);
  textSize(25);
  text("Réglage de la clé USB", 160, 60);
  textSize(15);
  text("Choix de l'identifiant :", 50, 120);
  if (modif==true) {
    text("Identifiant :", 100, 270);
    text("Mot de passe :", 100, 320);
    text("Confirmation :", 100, 370);
  } else if (suppr<4) {
    //un delai est necessaire entre deux suppression donc on supprime un cadre par image affichée
    switch(suppr) {
    case 0:
      cp5.remove("id");
      break;
    case 1:
      cp5.remove("mp");
      break;
    case 2:
      cp5.remove("cf");
      break;
    case 3:
      cp5.remove("Valider");
      break;
    }
    suppr++;
  }
}

void Identifiants(int n) {//interuption declenchée lors de la séléction d'un élément de la list
  num=n;
}


void Modifier() {
  modif=true;

  cp5.addTextfield("id")
    .setPosition(220, 250)
      .setSize(200, 30)
        .setFont(font)
          .setFocus(true)
            .setAutoClear(false)
              .setColor(color(255))
                //.setText()//afficher l'identifiant selectionné
                ;

  cp5.addTextfield("mp")
    .setPosition(220, 300)
      .setSize(200, 30)
        .setFont(font)
          .setFocus(true)
            .setAutoClear(false)
              .setColor(color(255))
                .setPasswordMode(true)
                  ;  

  cp5.addTextfield("cf")
    .setPosition(220, 350)
      .setSize(200, 30)
        .setFont(font)
          .setFocus(true)
            .setAutoClear(false)
              .setColor(color(255))
                .setPasswordMode(true)
                  ;

  cp5.addButton("Valider")
    .setPosition(220, 400)
      .setSize(200, 25)
        ;
}


public void Valider() {
  if ((cp5.get(Textfield.class, "id").getStringValue() != "") && (cp5.get(Textfield.class, "mp").getStringValue() != "")) {
    println(cp5.get(Textfield.class, "id").getStringValue()+'\n'+cp5.get(Textfield.class, "mp").getStringValue()+'\n'+cp5.get(Textfield.class, "cf").getStringValue());
    if (cp5.get(Textfield.class, "mp").getStringValue().equals(cp5.get(Textfield.class, "cf").getStringValue()) == true ) {
      println("OK");
      id[num]=cp5.get(Textfield.class, "id").getStringValue();
      mp[num]=cp5.get(Textfield.class, "mp").getStringValue();
      cp5.get(ScrollableList.class, "Identifiants").setItems(id);
      suppr=0;
      modif=false;

      changer(num);
      demande();
    }
  }
}


/************************
 * partie communication *
 ************************/


//demande mp
void demande() {
  myPort.write("1"+'\n');
  //myPort.write('\n');
  println("demandé");
}

//envoie nouveau mp
void changer(int num) {
  myPort.write("2"+'\n'+num+'\n'+id[num]+'\n'+mp[num]+'\n');

}

void lecture() {
  char I[]=new char[16];
  char M[]=new char[16];


  if (dec<2) {
    int i=dec+2;                   //apres 3\n

    for (int j=0; j<4; j++) {
      int k=0;
      //int num=inBuffer[i];
      i+=2;                        //apres 3 \n num \n
      do {
        I[k]=char(inBuffer[i]);
        i++;
        k++;
      }
      while ( (inBuffer[i]!='\n')&&(k<15));
      id[j]=new String(I);
      print("id:");
      println(id[j]);
      i++;
      k=0;

      do {
        M[k]=char(inBuffer[i]);
        i++;
        k++;
      }
      while ( (inBuffer[i]!='\n')&&(k<15));
      mp[j]=new String(M);
      print("mp:");
      println(mp[j]);
      i++;
    }
    if(init==false) cp5.get(ScrollableList.class, "Identifiants").setItems(id);
    else finInit=true;
    dec=2;
  }
}






void serialEvent(Serial myPort) {
  println("reçu");
  myPort.readBytesUntil(0x0d, inBuffer);

  if (inBuffer != null) {
    myString = new String(inBuffer);
    println(myString);
    if (inBuffer[0]=='3') {
      dec=0;
      println("correct");
    } else if (inBuffer[1] == '3') {
      dec=1;
      println("ok");
    } else dec =2;
  }
  
}

