#include <EEPROM.h>

char bp[4] = {1 << PD5, 1 << PD4, 1 << PD7, 1 << PD6};
char led[4] = {1 << PF4, 1 << PF5, 1 << PF6, 1 << PF7};

/***************************
à ajouter:
      séquence par défaut
****************************/


/************************
 * partie communication *
 ************************/

void change() {
  byte* r;
  Serial.readBytesUntil('\n', r, 15);
  byte num = r[0] - '0';

  char id[16];
  for (int i = 0; i < 16; i++) id[i] = 0;
  while (Serial.available() == 0);
  Serial.readBytesUntil('\n', id, 15);

  char mp[16];
  for (int i = 0; i < 16; i++) mp[i] = 0;
  while (Serial.available() == 0);
  Serial.readBytesUntil('\n', mp, 15);

  char i = 0;
  char adresse = 0x10 + num * 0x20;
  do {
    if (EEPROM.read(i + adresse) != id[i]) EEPROM.write( i + adresse, id[i]);
    i++;
  } while (id[i] != 0);
  if (EEPROM.read(i + adresse) != 0) EEPROM.write( i + adresse, 0);

  i = 0;
  adresse += 0x10;
  do {
    if (EEPROM.read(i + adresse) != mp[i]) EEPROM.write( i + adresse, mp[i]);
    i++;
  } while (mp[i] != 0);
  if (EEPROM.read(i + adresse) != 0) EEPROM.write( i + adresse, 0);
}


void liste() {
  Serial.print(3);
  Serial.print('\n');

  char adresse = 0x10;
  for (int n = 0; n < 4; n++) {
    Serial.print(n + "\n");
    char i = 0;
    do {
      char c = EEPROM.read(adresse + i);
      Serial.print(c);
      i++;
    } while (EEPROM.read(adresse + i) != 0);
    adresse += 0x10;
    i = 0;
    do {
      char c = EEPROM.read(adresse + i);
      Serial.print(c);
      i++;
    } while (EEPROM.read(adresse + i) != 0);
    adresse += 0x10;
  }
}




/**************
 * partie HID *
 **************/

char translate(char c) {
  switch (c) {
    case '1':
      c = '!';
      break;
    case '2':
      c = '@';
      break;
    case '3':
      c = '#';
      break;
    case '4':
      c = '$';
      break;
    case '5':
      c = '%';
      break;
    case '6':
      c = '^';
      break;
    case '7':
      c = '&';
      break;
    case '8':
      c = '*';
      break;
    case '9':
      c = '(';
      break;
    case '0':
      c = ')';
      break;
    case '°':
      c = '_';
      break;
    case '&':
      c = '1';
      break;
    case 'é':
      c = '2';
      break;
    case '"':
      c = '3';
      break;
    case '(':
      c = '5';
      break;
    case '-':
      c = '6';
      break;
    case 'è':
      c = '7';
      break;
    case '_':
      c = '8';
      break;
    case 'ç':
      c = '9';
      break;
    case 'à':
      c = '0';
      break;
    case ')':
      c = '-';
      break;
    case 'a':
      c = 'q';
      break;
    case 'A':
      c = 'Q';
      break;
    case 'z':
      c = 'w';
      break;
    case 'Z':
      c = 'W';
      break;
    case '^':
      c = '[';
      break;
    case '$':
      c = ']';
      break;
    case '£':
      c = '}';
      break;
    case 'q':
      c = 'a';
      break;
    case 'Q':
      c = 'A';
      break;
    case 'm':
      c = ';';
      break;
    case 'M':
      c = ':';
      break;
    case 'µ':
      c = '|';
      break;
    case 'w':
      c = 'z';
      break;
    case 'W':
      c = 'Z';
      break;
    case ',':
      c = 'm';
      break;
    case '?':
      c = 'M';
      break;
    case ';':
      c = ',';
      break;
    case '.':
      c = '<';
      break;
    case ':':
      c = '.';
      break;
    case '/':
      c = '>';
      break;
    case '!':
      c = '/';
      break;
    default:
      break;
  }
  return c;

}


void login(char num) {
  Keyboard.begin();
  char adresse = 0x10 + 0x20 * num;
  char i = 0;
  do {
    char c = EEPROM.read(adresse + i);
    Keyboard.print(translate(c));
    i++;
  } while (EEPROM.read(adresse + i) != 0);
  Keyboard.write(KEY_TAB);
  i = 0;
  adresse += 0x10;
  do {
    char c = EEPROM.read(adresse + i);
    Keyboard.print(translate(c));
    i++;
  } while (EEPROM.read(adresse + i) != 0);
  Keyboard.println("");//==write(KEY_RETURN)
  Keyboard.end();
}


/*********************
 * partie principale *
 *********************/

void setup() {
  Serial.begin(9600);

  DDRD = 0;
  PORTD = 0xf0;
  DDRF = 0xf0;
  PORTF = 0xf0;
}


void loop() {
  for (char i = 0; i < 4; i++) {
    if ((PIND & bp[i]) == 0) {
      PORTF ^= led[i];
      login(i);
      delay(100);
      PORTF ^= led[i];
    }
  }
}



void serialEvent() {
  byte* r;
  Serial.readBytesUntil('\n', r, 15);
  if (r[0] == 1) liste();
  else if (r[0] == 2) change();
}

/* */
